/* Levee d'exceptions depuis C */

#include <setjmp.h>
#include "mlvalues.h"
#include "alloc.h"
#include "fail.h"

jmp_buf * external_raise = 0;
value exn_bucket;

void mlraise(v)
     value v;
{
  exn_bucket = v;
  longjmp(*external_raise, 1);
}

static void raise_with_arg(tag, arg)
     unsigned int tag;
     value arg;
{
  value bucket;
  PUSH_ROOTS (a, 1);
  a [0] = arg;

  SMALL_ALLOC(bucket, MAKE_HEADER(2, tag), 2);
  FIELD(bucket, 0) = a [0];
  POP_ROOTS ();
  mlraise(bucket);
}

static void raise_with_string(tag, msg)
     unsigned int tag;
     char * msg;
{
  value str;

  ALLOC_STRING(str, strlen(msg));
  strcpy(CSTRING(str), msg);
  raise_with_arg(tag, str);
}

void failwith (msg)
     char * msg;
{
  raise_with_string(FAILURE_EXN, msg);
}

void invalid_argument (msg)
     char * msg;
{
  raise_with_string(INVALID_EXN, msg);
}

void system_failwith_out_of_memory()
{
  mlraise(atom(OUT_OF_MEMORY));
}

void os_error()
{
  extern int errno;
  raise_with_arg(OS_EXN, MLINT(errno));
}
