/* hash.c */

#include <setjmp.h>
#include "mlvalues.h"
#include "memory.h"

static unsigned long hash_accu, hash_univ_limit, hash_univ_count;

static jmp_buf hash_exit;

static void hash_aux();

value hash_univ_param(count, limit, obj) /* ML */
     value obj, count, limit;
{
  hash_univ_limit = CINT(limit);
  hash_univ_count = CINT(count);
  hash_accu = 0;
  if (_setjmp(hash_exit) == 0) hash_aux(obj);
  return MLINT(hash_accu & MAX_MLINT);
}

#define ALPHA 65599
#define BETA 19
#define COMBINE(new)  (hash_accu = hash_accu * ALPHA + (new))
#define COMBINE_SMALL(new) (hash_accu = hash_accu * BETA + (new))
#define CHECK_COUNT() {if (--hash_univ_count < 0) _longjmp(hash_exit, 1);}
#define CHECK_LIMIT() {if (--hash_univ_limit < 0) _longjmp(hash_exit, 1);}

static void hash_aux(obj)
     value obj;
{
  unsigned char * p;
  blocksize i;

  CHECK_LIMIT();

  if ( IS_BLOCK(obj) && IS_ALLOCATED(obj))
    switch(TAG(obj)) {
    case TAG_STRING:
      CHECK_COUNT();
      GET_STRING_LENGTH(obj, i);
      for (p = &BYTE(obj, 0); i > 0; i--, p++)
        COMBINE_SMALL(*p);
      break;
    case TAG_BITVECT:
    case TAG_FLOAT:
      CHECK_COUNT();
      i = SIZE(obj);
      while (i != 0) {
        i--;
        COMBINE(FIELD(obj, i));
      }
      break;
    default:
      i = SIZE(obj);
      while (i != 0) {
        i--;
        hash_aux(FIELD(obj, i));
      }
      break;
    }
  else {
    CHECK_COUNT();
    COMBINE((long) obj);
  }
}
